Index: trunk/src/NTDLL/initterm.cpp
===================================================================
--- trunk/src/NTDLL/initterm.cpp	(revision 541)
+++ trunk/src/NTDLL/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:31 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:21 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/advapi32/initterm.cpp
===================================================================
--- trunk/src/advapi32/initterm.cpp	(revision 541)
+++ trunk/src/advapi32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:31 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:21 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/capi2032/initterm.cpp
===================================================================
--- trunk/src/capi2032/initterm.cpp	(revision 541)
+++ trunk/src/capi2032/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:31 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:21 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/comdlg32/initterm.cpp
===================================================================
--- trunk/src/comdlg32/initterm.cpp	(revision 541)
+++ trunk/src/comdlg32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:32 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:21 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/ddraw/initterm.cpp
===================================================================
--- trunk/src/ddraw/initterm.cpp	(revision 541)
+++ trunk/src/ddraw/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.7 1999-08-16 16:55:32 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.8 1999-08-18 08:58:21 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/dsound/initterm.cpp
===================================================================
--- trunk/src/dsound/initterm.cpp	(revision 541)
+++ trunk/src/dsound/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.4 1999-08-16 16:55:32 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.5 1999-08-18 08:58:21 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/gdi32/initterm.cpp
===================================================================
--- trunk/src/gdi32/initterm.cpp	(revision 541)
+++ trunk/src/gdi32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:32 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:21 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/lz32/initterm.cpp
===================================================================
--- trunk/src/lz32/initterm.cpp	(revision 541)
+++ trunk/src/lz32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.4 1999-08-17 19:30:49 phaller Exp $ */
+/* $Id: initterm.cpp,v 1.5 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -65,4 +65,6 @@
       case 0 :
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/mpr/initterm.cpp
===================================================================
--- trunk/src/mpr/initterm.cpp	(revision 541)
+++ trunk/src/mpr/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:32 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/ole32/initterm.cpp
===================================================================
--- trunk/src/ole32/initterm.cpp	(revision 541)
+++ trunk/src/ole32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:32 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/shell32/initterm.cpp
===================================================================
--- trunk/src/shell32/initterm.cpp	(revision 541)
+++ trunk/src/shell32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:33 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/tapi32/initterm.cpp
===================================================================
--- trunk/src/tapi32/initterm.cpp	(revision 541)
+++ trunk/src/tapi32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:33 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/version/initterm.cpp
===================================================================
--- trunk/src/version/initterm.cpp	(revision 541)
+++ trunk/src/version/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:33 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/winspool/initterm.cpp
===================================================================
--- trunk/src/winspool/initterm.cpp	(revision 541)
+++ trunk/src/winspool/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:33 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/wnetap32/initterm.cpp
===================================================================
--- trunk/src/wnetap32/initterm.cpp	(revision 541)
+++ trunk/src/wnetap32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:33 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */
Index: trunk/src/wsock32/initterm.cpp
===================================================================
--- trunk/src/wsock32/initterm.cpp	(revision 541)
+++ trunk/src/wsock32/initterm.cpp	(revision 542)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.5 1999-08-16 16:55:33 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.6 1999-08-18 08:58:22 sandervl Exp $ */
 
 /*
@@ -72,4 +72,6 @@
          _ctordtorInit();
 
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
          /*******************************************************************/
          /* A DosExitList routine must be used to clean up if runtime calls */